#include <cassert>
#include <iostream>
#include <vector>
#include <stdexcept>

class SafeArray {
private:
    std::vector<int> data;

public:
    void push_back(int value) {
        data.push_back(value);
    }

    int& at(size_t index) {
        assert(index < data.size() && "Index out of bounds (assertion)");
        if (index >= data.size()) {
            throw std::out_of_range("Index out of bounds (exception)");
        }
        return data[index];
    }
};

int main() {
    SafeArray arr;
    arr.push_back(10);
    arr.push_back(20);

    try {
        std::cout << "Element at index 1: " << arr.at(1) << std::endl;
        std::cout << "Element at index 2: " << arr.at(2) << std::endl;
    }
    catch (const std::out_of_range& e) {
        std::cerr << "Exception caught: " << e.what() << std::endl;
    }

    return 0;
}
